#include <stdio.h>
#include <stdlib.h>

#include <windows.h>

int main(int argc, char *argv[])
{
    char *buffer;
    LARGE_INTEGER fsize;
    HANDLE fh;

    unsigned int chunk;

    if(argc < 2)
        goto err;

    fh = CreateFile(argv[1],GENERIC_READ,FILE_SHARE_READ,
                    NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING,0);
    if(fh == INVALID_HANDLE_VALUE)
        goto err;

    GetFileSizeEx(fh, &fsize);

    printf("file size is %I64d\n",fsize.QuadPart);

    buffer = VirtualAlloc(NULL, 64*1024*1024,MEM_COMMIT | MEM_RESERVE,PAGE_READWRITE);
    if(buffer == NULL)
        goto err1;

    for(chunk = 4096; chunk <= 64*1024*1024; chunk<<=1)
    {
        long long pos;
        long long iter;
        long long total;
        int  tmp;
        char *str;
        DWORD end_time, count;

        pos = SetFilePointer(fh,0,NULL,FILE_BEGIN);
        if (pos == INVALID_SET_FILE_POINTER)
            goto err2;

        end_time = timeGetTime()+16000;

        iter = 0;
        do
        {
            if(FALSE == ReadFile(fh,buffer,chunk,&count,NULL))
            {
                printf("unable to read from file.\n");
                goto err3;
            };

            pos += chunk;
            iter++;
            if( pos+chunk >= fsize.QuadPart)
            {
                pos = SetFilePointer(fh,0,NULL,FILE_BEGIN);
                if (pos == INVALID_SET_FILE_POINTER)
                    goto err2;
            }
        }while (end_time > timeGetTime());

        total = chunk*iter/16384;
        if(chunk >= 1024*1024)
        {
            tmp = chunk >> 20;
            str = "MB";
        }
        else if(chunk >= 1024)
        {
            tmp = chunk >> 10;
            str = "KB";
        }
        else
        {
            tmp = chunk;
            str = "";
        }

        printf("chunk %d %s iterations %I64d speed %I64d KB/s\n", tmp, str, iter, total);
    }

    return 0;

err:
    printf("Usage: fspeed testfile\n");

    return 0;

err1:
    printf("No enough memory for read buffer\n");
    CloseHandle(fh);

    return 0;

err2:
    printf("lseek to beginning failed\n");
err3:
    VirtualFree(buffer, 0, MEM_RELEASE);
    CloseHandle(fh);

    return 0;
}
